package com.example.tests;

import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.net.Uri;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.Toast;

public class Intents extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		EditText et = (EditText) findViewById(R.id.editText1);
		et.addTextChangedListener(new TextWatcher(){

			@Override
			public void afterTextChanged(Editable arg0) {
				RadioGroup rg = (RadioGroup) findViewById(R.id.radioGroup1);
				if (arg0.toString().startsWith("http://")){
					rg.check(R.id.radio0);
				}else if (arg0.toString().startsWith("tel:")){
					rg.check(R.id.radio1);
				}else if(arg0.toString().startsWith("geo:")){
					rg.check(R.id.radio2);
				}
			}

			@Override
			public void beforeTextChanged(CharSequence arg0, int arg1,
					int arg2, int arg3) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void onTextChanged(CharSequence arg0, int arg1, int arg2,
					int arg3) {
				// TODO Auto-generated method stub
				
			}
	
		});
	}

	public void sendIntent(View view){
		Intent intent = null;
		EditText et = (EditText) findViewById(R.id.editText1);
		RadioGroup rg = (RadioGroup) findViewById(R.id.radioGroup1);

		Uri target = Uri.parse(et.getText().toString());

		switch (rg.getCheckedRadioButtonId()){
			case R.id.radio0:
				Toast.makeText(this, "Web", Toast.LENGTH_LONG).show();
				intent = new Intent(Intent.ACTION_VIEW, target);
				break;
			case R.id.radio1:
				Toast.makeText(this, "Phone", Toast.LENGTH_LONG).show();				
				intent = new Intent(Intent.ACTION_DIAL, target);
				break;
			case R.id.radio2:
				Toast.makeText(this, "Maps", Toast.LENGTH_LONG).show();
				intent = new Intent(Intent.ACTION_VIEW, target);
				break;
		}
		// Verify it resolves
		PackageManager packageManager = getPackageManager();
		List<ResolveInfo> activities = packageManager.queryIntentActivities(intent, 0);
		boolean isIntentSafe = activities.size() > 0;

		// Start an activity if it's safe
		if (isIntentSafe) {
		    startActivity(intent);
		}else{
			Toast.makeText(this, "Intent is not safe", Toast.LENGTH_LONG).show();
		}
	}

}
